# std::__debug::bitset< _Nb > Class Template Reference

Class std::bitset with additional safety/checking/debug instrumentation. More...

Inheritance diagram for std::__debug::bitset< _Nb >:
[legend]

List of all members.

## Public Member Functions

- bitset (unsigned long long __val)
- template<class _CharT , class _Traits , class _Alloc > bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__str, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __pos, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __n, _CharT __zero, _CharT __one=_CharT('1'))
- bitset (const _Base &__x)
- template<typename _CharT , typename _Traits , typename _Alloc > bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__str, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __pos=0, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __n=(std::basic_string< _CharT, _Traits, _Alloc >::npos))
- bitset (const char *__str)
- _Base & _M_base ()
- const _Base & _M_base () const
- void _M_invalidate_all () const
- bitset< _Nb > & flip ()
- bitset< _Nb > & flip (size_t __pos)
- bool operator!= (const bitset< _Nb > &__rhs) const
- bitset< _Nb > & operator&= (const bitset< _Nb > &__rhs)
- bitset< _Nb > operator<< (size_t __pos) const
- bitset< _Nb > & operator<<= (size_t __pos)
- bool operator== (const bitset< _Nb > &__rhs) const
- bitset< _Nb > operator>> (size_t __pos) const
- bitset< _Nb > & operator>>= (size_t __pos)
- reference operator[] (size_t __pos)
- bool operator[] (size_t __pos) const
- bitset< _Nb > & operator^= (const bitset< _Nb > &__rhs)
- bitset< _Nb > & operator|= (const bitset< _Nb > &__rhs)
- bitset< _Nb > operator~ () const
- bitset< _Nb > & reset ()
- bitset< _Nb > & reset (size_t __pos)
- bitset< _Nb > & set ()
- bitset< _Nb > & set (size_t __pos, bool __val=true)
- std::basic_string< char,
  std::char_traits< char >
  , std::allocator< char > > to_string (char __zero, char __one= '1') const
- template<typename _CharT > std::basic_string< _CharT,
  std::char_traits< _CharT >
  , std::allocator< _CharT > > to_string () const
- template<typename _CharT , typename _Traits > std::basic_string< _CharT,
  _Traits, std::allocator
  < _CharT > > to_string () const
- template<class _CharT > std::basic_string< _CharT,
  std::char_traits< _CharT >
  , std::allocator< _CharT > > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
- std::basic_string< char,
  std::char_traits< char >
  , std::allocator< char > > to_string () const
- template<class _CharT , class _Traits > std::basic_string< _CharT,
  _Traits, std::allocator
  < _CharT > > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
- template<class _CharT , class _Traits , class _Alloc > std::basic_string< _CharT,
  _Traits, _Alloc > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
- template<typename _CharT , typename _Traits , typename _Alloc > std::basic_string< _CharT,
  _Traits, _Alloc > to_string () const

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex () throw ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Detailed Description

### template<size_t _Nb>
class std::__debug::bitset< _Nb >

Class std::bitset with additional safety/checking/debug instrumentation.

Definition at line 43 of file debug/bitset.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | throw ()`[protected, inherited]`

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 215 of file safe_base.h.

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators `[inherited]`

The list of constant iterators that reference this container.

Definition at line 166 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators `[inherited]`

The list of mutable iterators that reference this container.

Definition at line 163 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version `[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 169 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/bitset